/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.hadoop.hive.ql.exec;

import static org.junit.Assert.assertTrue;

import java.util.Optional;

import org.apache.calcite.rel.type.RelDataType;
import org.apache.hadoop.hive.ql.exec.DataSketchesFunctions.SketchFunctionDescriptor;
import org.junit.Test;

public final class TestDataSketchesFunctions {

  @Test
  public void testKllGetCdfReturnType() {
    SketchFunctionDescriptor cf =
        DataSketchesFunctions.INSTANCE.getSketchFunction("kll", DataSketchesFunctions.GET_CDF);
    Optional<RelDataType> retType = cf.getReturnRelDataType();
    assertTrue(retType.get().getComponentType() != null);
  }
}
